SystemOrganization addCategory: #PomodoroTechnique!

PluggableButtonMorph subclass: #PomodoroSimpleButton
	instanceVariableNames: 'stepsLeft'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PomodoroTechnique'!

!PomodoroSimpleButton commentStamp: 'sab 5/20/2012 20:27' prior: 0!
PomodoroSimpleButton new
!

!PomodoroSimpleButton methodsFor: 'as yet unclassified' stamp: 'sab 4/28/2012 23:04'!
clickAction
	self isStepping
		ifTrue: [ self stopStepping ]
		ifFalse: [ self startStepping ]! !

!PomodoroSimpleButton methodsFor: 'as yet unclassified' stamp: 'sab 4/28/2012 22:24'!
end
	self stopStepping.
	self label: 'Well done!!!!'.
	stepsLeft := self stepsDuration.
	Pomodoro alert.! !

!PomodoroSimpleButton methodsFor: 'as yet unclassified' stamp: 'sab 4/29/2012 00:45'!
initialize
	super initialize.
	stepsLeft := self stepsDuration.
	self
		label: 'click to start';
		model: self;
		action: #clickAction;
		openInHand.
! !

!PomodoroSimpleButton methodsFor: 'as yet unclassified' stamp: 'sab 4/28/2012 22:58'!
step
	stepsLeft >= 1
		ifTrue: [ 
			stepsLeft := stepsLeft - 1.
			self label: stepsLeft asString ]
		ifFalse: [ self end ]! !

!PomodoroSimpleButton methodsFor: 'as yet unclassified' stamp: 'sab 4/28/2012 22:05'!
stepTime
^ 1000 "1 sec"! !

!PomodoroSimpleButton methodsFor: 'as yet unclassified' stamp: 'sab 4/28/2012 22:56'!
stepsDuration
	^ 60 * 25	"1500 seconds"! !

Object subclass: #Pomodoro
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PomodoroTechnique'!

!Pomodoro commentStamp: 'sab 5/20/2012 20:38' prior: 0!
Pomodoro class brings visual and sound alerts for 2 kind of timers: 

* PomodoroSimpleButton uses stepping from Morphic system

* PomodoroTimer has a bit complex gui, owns his window and it creates a separate process to countdown. 

 Actually both are inaccurate and buggy... therefore it can be improved!

!Pomodoro class methodsFor: 'as yet unclassified' stamp: 'sab 4/28/2012 22:23'!
alert
 self visualAlert
	soundAlert.! !

!Pomodoro class methodsFor: 'as yet unclassified' stamp: 'sab 5/5/2012 21:17'!
soundAlert
	BaseSoundSystem soundEnabled
		ifTrue: [ 
			10
				timesRepeat: [ 
					FMSound randomWeird1 play.
					(Delay forMilliseconds: 200) wait ] ]! !

!Pomodoro class methodsFor: 'private' stamp: 'sab 4/28/2012 22:23'!
visualAlert
	| rainbow |
	rainbow := Color red wheel: 6.
	rainbow
		do: [ :aColor | 
			Display fillColor: aColor.
			(Delay forMilliseconds: 60) wait ].
	Display restore! !

Object subclass: #PomodoroTimer
	instanceVariableNames: 'running secondsLeft subProcess labelText gui label'
	classVariableNames: 'duration labelFont'
	poolDictionaries: ''
	category: 'PomodoroTechnique'!

!PomodoroTimer commentStamp: 'sab 5/20/2012 20:23' prior: 0!
PomodoroTimer new open.!

!PomodoroTimer class methodsFor: 'as yet unclassified' stamp: 'sab 4/23/2012 01:12'!
initialize
	duration ifNil: [duration := Time fromSeconds: 15 * 60 ].
	labelFont := LogicalFont familyName: 'FreeMono' pointSize: 32.
	super initialize.! !

!PomodoroTimer methodsFor: 'private' stamp: 'sab 4/12/2012 23:03'!
asMmSs
| time mm ss |
time := Time fromSeconds: secondsLeft.
mm := time minutes printStringBase: 10 nDigits: 2.
ss := time seconds printStringBase: 10 nDigits: 2.
^ mm , ':', ss! !

!PomodoroTimer methodsFor: 'actions' stamp: 'sab 4/23/2012 00:31'!
duration
| currentDuration input |
currentDuration := (Duration seconds: secondsLeft ) asString.
input:= UITheme builder 
			textEntry: 'Enter new timer duration formatted like days:hours:minutes:seconds' 
			title: 'Change duration value' 
			entryText: currentDuration.
input ifNotNil: [ duration := Duration fromString: input. ]
! !

!PomodoroTimer methodsFor: 'as yet unclassified' stamp: 'sab 4/28/2012 22:21'!
finish
	running := false.
	self
		log: 'Finished';
		initialize.
Pomodoro alert. ! !

!PomodoroTimer methodsFor: 'actions' stamp: 'sab 4/12/2012 21:47'!
font
	label changeFont.! !

!PomodoroTimer methodsFor: 'actions' stamp: 'sab 4/12/2012 23:02'!
getLabel
^ labelText := self asMmSs.
! !

!PomodoroTimer methodsFor: 'initialization' stamp: 'sab 4/22/2012 23:59'!
initialize 
	running := false.
	secondsLeft := duration asSeconds.
	labelText := self asMmSs.
	super initialize.
! !

!PomodoroTimer methodsFor: 'private' stamp: 'sab 4/22/2012 23:25'!
launchProcess
	subProcess := [ 
		[ secondsLeft > 0 ] whileTrue: [ self tic ].
	self finish ] fork! !

!PomodoroTimer methodsFor: 'private' stamp: 'sab 4/12/2012 22:04'!
log: aText
	Transcript
		show: DateAndTime current asString;
		show: ' ' , self class asString;
		show: ' ' , aText;
		cr! !

!PomodoroTimer methodsFor: 'private' stamp: 'sab 4/23/2012 00:48'!
open
| b |
b := UITheme builder.
gui :=  b newColumn: {
  	label := b newLabelFor: self getLabel: #getLabel getEnabled: nil. 
	label font: labelFont.
  	b newRow: {
    		b newButtonFor: self action: #start label: 'start' help: nil.
    		b newButtonFor: self action: #reset label: 'reset' help: nil.
   		b newButtonFor: self action: #font label: 'font' help: nil.
   		b newButtonFor: self action: #duration label: 'duration' help: nil.
	}.
  	b newRow: {
    		b newButtonFor: self action: [ self halt ] label: 'halt' help: nil.
 	}.
}.
( gui openInWindowLabeled: 'tomate' ) extent: 200@100. ! !

!PomodoroTimer methodsFor: 'actions' stamp: 'sab 4/22/2012 22:51'!
reset
	self log: ( 'Cancelled when remains ' , labelText).
	running := false.
	subProcess ifNotNil: [subProcess terminate].
	self changed: #getLabel.
	self initialize.! !

!PomodoroTimer methodsFor: 'actions' stamp: 'sab 4/12/2012 23:19'!
start
	running
		ifFalse: [ 
			self log: 'Started'.
			running := true.
			self launchProcess ]! !

!PomodoroTimer methodsFor: 'as yet unclassified' stamp: 'sab 4/22/2012 23:26'!
tic 
	(Delay forSeconds: 1) wait.
	secondsLeft := secondsLeft - 1. 
	self changed: #getLabel.! !
PomodoroTimer initialize!
